package BAST::Datasource::Composite;

use strict;
use warnings;

use base qw/BAST::Datasource/;

__PACKAGE__->has_children(datasource => 'BAST::Datasource');
__PACKAGE__->has_children(transform => 'BAST::Transform');
__PACKAGE__->has_children(evaluate => 'BAST::Evaluate');
__PACKAGE__->has_children(invoke => 'BAST::Invoke');

sub process {
  my ($self, $ctx) = @_;
  #print join("\n-\n", $self->search_children());
  #die;
  my @ret =
    (map { (ref $_ eq 'ARRAY' ? @$_ : $_) }
    #map { ($_->isa('BAST::Datasource')
    #        ? $_->process($ctx)->findnode("/data/*")
    #        : $_->process($ctx)); }
    #map { warn "Res: $_"; $_; }
    map { $_->process($ctx); }
    sort { $a->get_pos <=> $b->get_pos } $self->search_children);
  my $ret = (@ret > 1 ? $self->anon_data(@ret) : $ret[0]);
  return $self->anon_data($ret);
}

1;
