package BAST::Evaluate;

use strict;
use warnings;
use base qw/Class::XML/;

__PACKAGE__->has_child(datasource => 'BAST::Datasource');

sub process {
  my ($self, $ctx, $old_ctx) = @_;
  my (@tree) = $self->datasource->process($old_ctx || $ctx)->findnodes("*");
  my @ret;
  foreach my $tree (grep { defined $_ } @tree) {
    Class::XML::cast('BAST::'.ucfirst($tree->getLocalName), $tree);
    push(@ret, $tree->process($ctx));
  }
  return @ret;
}

1;
