package BAST::Transform;

use BAST::Transformer;
use base qw/Class::XML/;
use strict;
use warnings;

__PACKAGE__->has_attributes(qw/href/);
__PACKAGE__->has_child(datasource => 'BAST::Datasource');
__PACKAGE__->has_child(transform => 'BAST::Transform');
__PACKAGE__->has_child(transformer => 'BAST::Transformer');

sub process {
  my ($self, $ctx) = @_;
  my $transformer;
  if (defined $self->href) {
    $transformer = Class::XML::cast('BAST::Transformer',
                     $ctx->get_path($self->href));
  } else {
    $transformer = $self->transformer;
  }

  die "Must have valid href or inline <transformer>" unless $transformer;

  my $source = $self->datasource || $self->transform;
  return $transformer->process($ctx, $source->process($ctx));
}

1;
