package BAST::Transformer::XSLT::stylesheet;

use base qw/Class::XML/;
use XML::LibXML;
use XML::LibXSLT;
use strict;
use warnings;

sub process {
  my ($self, $source) = @_;
  my $parser = new XML::LibXML;
  my $xslt = new XML::LibXSLT;
  my $style_doc = $parser->parse_string($self->toString);
  my $source_doc = $parser->parse_string($source->toString);
  #warn "Here (style ".$style_doc->toString.", source ".$source_doc->toString."\n";
  my $stylesheet = $xslt->parse_stylesheet($style_doc);
  my $results = $stylesheet->transform($source_doc);
  die "Results undef" unless $results;
  return Class::XML->new(xml => $results->toString); # ->findnodes("*");
}

1;
