<transformer class="XSLT">
  <xsl:stylesheet xsl:version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:template match="*">
      <xsl:copy>
        <xsl:copy-of select="@*" />
        <xsl:apply-templates />
      </xsl:copy>
    </xsl:template>
    <xsl:template match="table">
      <xsl:copy>
        <xsl:copy-of select="@*" />
        <field name="id" class="Integer" untaint_type="integer" />
        <xsl:apply-templates />
      </xsl:copy>
    </xsl:template>
    <xsl:template match="field">
      <xsl:copy>
        <xsl:copy-of select="@*" />
        <xsl:attribute name="untaint_type">
          <xsl:choose>
            <xsl:when test="@class='FK' or @class='Integer'">
              <xsl:text>integer</xsl:text>
            </xsl:when>
            <xsl:when test="@class='Image'">
               <xsl:text>like_anything</xsl:text>
            </xsl:when>
            <xsl:otherwise>
              <xsl:text>printable</xsl:text>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:attribute>
        <xsl:if test="@class='Image'">
           <xsl:attribute name="edit">file</xsl:attribute>
        </xsl:if>
        <xsl:apply-templates />
      </xsl:copy>
    </xsl:template>
    <xsl:template match="relation">
      <xsl:copy>
        <xsl:copy-of select="@*" />
        <xsl:choose>
          <!-- <xsl:when test="@class='many_to_many' and @ordered">
            <xsl:attribute name="method">has_many_ordered</xsl:attribute>
            <xsl:attribute name="extra_args">, { order_by => 'order_by', map => '<xsl:value-of select="@from" />_<xsl:value-of select="@to" />' } </xsl:attribute>
          </xsl:when> -->
          <xsl:when test="@class='many_to_many'">
            <xsl:attribute name="method">has_many_to_many</xsl:attribute>
          </xsl:when>
        </xsl:choose>
        <xsl:apply-templates />
      </xsl:copy>
    </xsl:template>
  </xsl:stylesheet>
</transformer>
