use Class::DBI;
$Class::DBI::Weaken_Is_Available = 0;
package FCB_ShellieMark::DB;

use base qw/Class::DBI Maypole::Model::Base/;
  # Model::Base for :Exported attribute handling
use Class::DBI::Relationship::HasManyToMany;

__PACKAGE__->add_relationship_type(
  has_many_to_many => "Class::DBI::Relationship::HasManyToMany",
);

__PACKAGE__->connection('dbi:mysql:host=localhost;database=fcb_shelliemark', 'mdk', '');


package FCB_ShellieMark::DB::user;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('user');
__PACKAGE__->columns(Essential => qw/ id name password security_role/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id name password security_role/;
}


__PACKAGE__->has_a('security_role' => 'FCB_ShellieMark::DB::security_role');
FCB_ShellieMark::DB::security_role->has_many('user', 'FCB_ShellieMark::DB::user' => 'security_role');

__PACKAGE__->untaint_columns(
  integer => [qw/id security_role /],
  printable => [qw/name password /],
);



package FCB_ShellieMark::DB::user_card;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('user_card');
__PACKAGE__->columns(Essential => qw/ id name user cardholder_name card_number valid_from valid_to issue_number extra_code address_name address_street address_city address_state address_zip/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id name user cardholder_name card_number valid_from valid_to issue_number extra_code address_name address_street address_city address_state address_zip/;
}


__PACKAGE__->has_a('user' => 'FCB_ShellieMark::DB::user');
FCB_ShellieMark::DB::user->has_many('user_card', 'FCB_ShellieMark::DB::user_card' => 'user');

__PACKAGE__->untaint_columns(
  integer => [qw/id user /],
  printable => [qw/name cardholder_name card_number valid_from valid_to issue_number extra_code address_name address_street address_city address_state address_zip /],
);



package FCB_ShellieMark::DB::user_address;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('user_address');
__PACKAGE__->columns(Essential => qw/ id name user address_name address_street address_city address_state address_zip/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id name user address_name address_street address_city address_state address_zip/;
}


__PACKAGE__->has_a('user' => 'FCB_ShellieMark::DB::user');
FCB_ShellieMark::DB::user->has_many('user_address', 'FCB_ShellieMark::DB::user_address' => 'user');

__PACKAGE__->untaint_columns(
  integer => [qw/id user /],
  printable => [qw/name address_name address_street address_city address_state address_zip /],
);



package FCB_ShellieMark::DB::invoice;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('invoice');
__PACKAGE__->columns(Essential => qw/ id user reference created processed/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id user reference created processed/;
}


__PACKAGE__->has_a('user' => 'FCB_ShellieMark::DB::user');
FCB_ShellieMark::DB::user->has_many('invoice', 'FCB_ShellieMark::DB::invoice' => 'user');

__PACKAGE__->untaint_columns(
  integer => [qw/id user /],
  printable => [qw/reference created processed /],
);



package FCB_ShellieMark::DB::invoice_line;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('invoice_line');
__PACKAGE__->columns(Essential => qw/ id invoice name class item_id unit_price quantity tax_name tax_percentage/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id invoice name class item_id unit_price quantity tax_name tax_percentage/;
}


__PACKAGE__->has_a('invoice' => 'FCB_ShellieMark::DB::invoice');
FCB_ShellieMark::DB::invoice->has_many('invoice_line', 'FCB_ShellieMark::DB::invoice_line' => 'invoice');

__PACKAGE__->untaint_columns(
  integer => [qw/id invoice item_id quantity /],
  printable => [qw/name class unit_price tax_name tax_percentage /],
);



package FCB_ShellieMark::DB::invoice_card;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('invoice_card');
__PACKAGE__->columns(Essential => qw/ id name invoice cardholder_name card_number valid_from valid_to issue_number extra_code address_name address_street address_city address_state address_zip/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id name invoice cardholder_name card_number valid_from valid_to issue_number extra_code address_name address_street address_city address_state address_zip/;
}


__PACKAGE__->has_a('invoice' => 'FCB_ShellieMark::DB::invoice');
FCB_ShellieMark::DB::invoice->has_many('invoice_card', 'FCB_ShellieMark::DB::invoice_card' => 'invoice');

__PACKAGE__->untaint_columns(
  integer => [qw/id invoice /],
  printable => [qw/name cardholder_name card_number valid_from valid_to issue_number extra_code address_name address_street address_city address_state address_zip /],
);



package FCB_ShellieMark::DB::invoice_address;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('invoice_address');
__PACKAGE__->columns(Essential => qw/ id name invoice address_name address_street address_city address_state address_zip/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id name invoice address_name address_street address_city address_state address_zip/;
}


__PACKAGE__->has_a('invoice' => 'FCB_ShellieMark::DB::invoice');
FCB_ShellieMark::DB::invoice->has_many('invoice_address', 'FCB_ShellieMark::DB::invoice_address' => 'invoice');

__PACKAGE__->untaint_columns(
  integer => [qw/id invoice /],
  printable => [qw/name address_name address_street address_city address_state address_zip /],
);



package FCB_ShellieMark::DB::site;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('site');
__PACKAGE__->columns(Essential => qw/ id domain name stylesheet background_image/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id domain name stylesheet background_image/;
}


__PACKAGE__->untaint_columns(
  integer => [qw/id /],
  printable => [qw/domain name stylesheet background_image /],
);



package FCB_ShellieMark::DB::page;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('page');
__PACKAGE__->columns(Essential => qw/ id name page_template url site order_in_site/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id name page_template url site order_in_site/;
}


__PACKAGE__->has_a('page_template' => 'FCB_ShellieMark::DB::page_template');
sub page_text_limit { return $_[0]->page_template->page_text_limit; }
sub page_image_limit { return $_[0]->page_template->page_image_limit; }
FCB_ShellieMark::DB::page_template->has_many('page', 'FCB_ShellieMark::DB::page' => 'page_template');

__PACKAGE__->has_a('site' => 'FCB_ShellieMark::DB::site');
FCB_ShellieMark::DB::site->has_many('page', 'FCB_ShellieMark::DB::page' => 'site', { order_by => 'order_in_site' });

__PACKAGE__->untaint_columns(
  integer => [qw/id page_template site order_in_site /],
  printable => [qw/name url /],
);

sub first : Exported { }


package FCB_ShellieMark::DB::page_template;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('page_template');
__PACKAGE__->columns(Essential => qw/ id name page_text_limit page_image_limit/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id name page_text_limit page_image_limit/;
}


__PACKAGE__->untaint_columns(
  integer => [qw/id page_text_limit page_image_limit /],
  printable => [qw/name /],
);



package FCB_ShellieMark::DB::page_text;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('page_text');
__PACKAGE__->columns(Essential => qw/ id page order_in_page heading text_style text/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id page order_in_page heading text_style text/;
}


__PACKAGE__->has_a('page' => 'FCB_ShellieMark::DB::page');
FCB_ShellieMark::DB::page->has_many('page_text', 'FCB_ShellieMark::DB::page_text' => 'page', { order_by => 'order_in_page' });

__PACKAGE__->has_a('text_style' => 'FCB_ShellieMark::DB::text_style');
FCB_ShellieMark::DB::text_style->has_many('page_text', 'FCB_ShellieMark::DB::page_text' => 'text_style');

__PACKAGE__->untaint_columns(
  integer => [qw/id page order_in_page text_style /],
  printable => [qw/heading text /],
);



package FCB_ShellieMark::DB::page_image;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('page_image');
__PACKAGE__->columns(Essential => qw/ id page order_in_page name image image_type alt/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id page order_in_page name image image_type alt/;
}


__PACKAGE__->has_a('page' => 'FCB_ShellieMark::DB::page');
FCB_ShellieMark::DB::page->has_many('page_image', 'FCB_ShellieMark::DB::page_image' => 'page', { order_by => 'order_in_page' });

sub do_edit : Exported {
  my ($self, $r) = @_;
  my $image_upload = $r->{ar}->upload('image');
  if ($image_upload) {
    my $ct = $image_upload->info("Content-type");
    return $r->error("Unknown image file type $ct")
      if $ct !~ m{image/(jpeg|gif|png)};
    #   return $r->error("File too big! Maximum size is ".MAX_IMAGE_SIZE)
    #       if $upload->size > MAX_IMAGE_SIZE; FIXME FIXME FIXME
    my $fh = $image_upload->fh;
    $r->{params}{'image'} = do { local $/; <$fh> };
    $r->{params}{'image_type'} = $ct;
  }
  return &{$self->can('SUPER::do_edit')};
}
__PACKAGE__->untaint_columns(
  integer => [qw/id page order_in_page /],
  printable => [qw/name image_type alt /],
  like_anything => [qw/image /],
);



package FCB_ShellieMark::DB::category;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('category');
__PACKAGE__->columns(Essential => qw/ id name site/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id name site/;
}


__PACKAGE__->has_a('site' => 'FCB_ShellieMark::DB::site');
FCB_ShellieMark::DB::site->has_many('category', 'FCB_ShellieMark::DB::category' => 'site');

__PACKAGE__->untaint_columns(
  integer => [qw/id site /],
  printable => [qw/name /],
);



package FCB_ShellieMark::DB::product;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('product');
__PACKAGE__->columns(Essential => qw/ id name author product_template category partner retail_price price isbn binding_type pages page_size illustrations colour_pictures publication_date published in_print weight/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id name author product_template category partner retail_price price isbn binding_type pages page_size illustrations colour_pictures publication_date published in_print weight/;
}


__PACKAGE__->has_a('author' => 'FCB_ShellieMark::DB::author');
FCB_ShellieMark::DB::author->has_many('product', 'FCB_ShellieMark::DB::product' => 'author');

__PACKAGE__->has_a('product_template' => 'FCB_ShellieMark::DB::product_template');
sub product_text_limit { return $_[0]->product_template->product_text_limit; }
sub product_image_limit { return $_[0]->product_template->product_image_limit; }
FCB_ShellieMark::DB::product_template->has_many('product', 'FCB_ShellieMark::DB::product' => 'product_template');

__PACKAGE__->has_a('category' => 'FCB_ShellieMark::DB::category');
FCB_ShellieMark::DB::category->has_many('product', 'FCB_ShellieMark::DB::product' => 'category');

__PACKAGE__->untaint_columns(
  integer => [qw/id author product_template category /],
  printable => [qw/name partner retail_price price isbn binding_type pages page_size illustrations colour_pictures publication_date published in_print weight /],
);



package FCB_ShellieMark::DB::product_template;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('product_template');
__PACKAGE__->columns(Essential => qw/ id name product_text_limit product_image_limit/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id name product_text_limit product_image_limit/;
}


__PACKAGE__->untaint_columns(
  integer => [qw/id product_text_limit product_image_limit /],
  printable => [qw/name /],
);



package FCB_ShellieMark::DB::product_text;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('product_text');
__PACKAGE__->columns(Essential => qw/ id product order_in_product heading text_style text/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id product order_in_product heading text_style text/;
}


__PACKAGE__->has_a('product' => 'FCB_ShellieMark::DB::product');
FCB_ShellieMark::DB::product->has_many('product_text', 'FCB_ShellieMark::DB::product_text' => 'product', { order_by => 'order_in_product' });

__PACKAGE__->has_a('text_style' => 'FCB_ShellieMark::DB::text_style');
FCB_ShellieMark::DB::text_style->has_many('product_text', 'FCB_ShellieMark::DB::product_text' => 'text_style');

__PACKAGE__->untaint_columns(
  integer => [qw/id product order_in_product text_style /],
  printable => [qw/heading text /],
);



package FCB_ShellieMark::DB::product_image;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('product_image');
__PACKAGE__->columns(Essential => qw/ id product order_in_product name image image_type alt/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id product order_in_product name image image_type alt/;
}


__PACKAGE__->has_a('product' => 'FCB_ShellieMark::DB::product');
FCB_ShellieMark::DB::product->has_many('product_image', 'FCB_ShellieMark::DB::product_image' => 'product', { order_by => 'order_in_product' });

sub do_edit : Exported {
  my ($self, $r) = @_;
  my $image_upload = $r->{ar}->upload('image');
  if ($image_upload) {
    my $ct = $image_upload->info("Content-type");
    return $r->error("Unknown image file type $ct")
      if $ct !~ m{image/(jpeg|gif|png)};
    #   return $r->error("File too big! Maximum size is ".MAX_IMAGE_SIZE)
    #       if $upload->size > MAX_IMAGE_SIZE; FIXME FIXME FIXME
    my $fh = $image_upload->fh;
    $r->{params}{'image'} = do { local $/; <$fh> };
    $r->{params}{'image_type'} = $ct;
  }
  return &{$self->can('SUPER::do_edit')};
}
__PACKAGE__->untaint_columns(
  integer => [qw/id product order_in_product /],
  printable => [qw/name image_type alt /],
  like_anything => [qw/image /],
);



package FCB_ShellieMark::DB::author;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('author');
__PACKAGE__->columns(Essential => qw/ id name qualifications/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id name qualifications/;
}


__PACKAGE__->untaint_columns(
  integer => [qw/id /],
  printable => [qw/name qualifications /],
);



package FCB_ShellieMark::DB::security_role;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('security_role');
__PACKAGE__->columns(Essential => qw/ id name/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id name/;
}


__PACKAGE__->untaint_columns(
  integer => [qw/id /],
  printable => [qw/name /],
);



package FCB_ShellieMark::DB::security_action;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('security_action');
__PACKAGE__->columns(Essential => qw/ id name action class/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id name action class/;
}


__PACKAGE__->untaint_columns(
  integer => [qw/id /],
  printable => [qw/name action class /],
);



package FCB_ShellieMark::DB::security_role_security_action;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('security_role_security_action');
__PACKAGE__->columns(Essential => qw/ id security_role security_action restricted/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id security_role security_action restricted/;
}


__PACKAGE__->has_a('security_role' => 'FCB_ShellieMark::DB::security_role');
FCB_ShellieMark::DB::security_role->has_many('security_role_security_action', 'FCB_ShellieMark::DB::security_role_security_action' => 'security_role');

__PACKAGE__->has_a('security_action' => 'FCB_ShellieMark::DB::security_action');
FCB_ShellieMark::DB::security_action->has_many('security_role_security_action', 'FCB_ShellieMark::DB::security_role_security_action' => 'security_action');

__PACKAGE__->untaint_columns(
  integer => [qw/id security_role security_action /],
  printable => [qw/restricted /],
);



package FCB_ShellieMark::DB::text_style;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('text_style');
__PACKAGE__->columns(Essential => qw/ id name class/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id name class/;
}


__PACKAGE__->untaint_columns(
  integer => [qw/id /],
  printable => [qw/name class /],
);



package FCB_ShellieMark::DB::delivery_method;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('delivery_method');
__PACKAGE__->columns(Essential => qw/ id name availability base_cost unit_cost min_cost discount_threshold discount_percentage/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id name availability base_cost unit_cost min_cost discount_threshold discount_percentage/;
}


__PACKAGE__->untaint_columns(
  integer => [qw/id /],
  printable => [qw/name availability base_cost unit_cost min_cost discount_threshold discount_percentage /],
);

sub choose : Exported { }
sub preview : Exported { }


package FCB_ShellieMark::DB::prod_raw_imp;

use base qw/FCB_ShellieMark::DB/;
use Class::DBI::FromCGI;

__PACKAGE__->table('prod_raw_imp');
__PACKAGE__->columns(Essential => qw/ id title AUTHOR PUBLISHER ISBNHARD PUBDATE BLURB PAGES illustration PAGESIZE BINDING1 ISBNSOFT PUBLISHED SALEBLURB whitdescribe DEFPRICE in_print partner colourpix series bindtype covertype authorqual/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id title AUTHOR PUBLISHER ISBNHARD PUBDATE BLURB PAGES illustration PAGESIZE BINDING1 ISBNSOFT PUBLISHED SALEBLURB whitdescribe DEFPRICE in_print partner colourpix series bindtype covertype authorqual/;
}


__PACKAGE__->untaint_columns(
  integer => [qw/id PAGES /],
  printable => [qw/title AUTHOR PUBLISHER ISBNHARD PUBDATE BLURB illustration PAGESIZE BINDING1 ISBNSOFT PUBLISHED SALEBLURB whitdescribe DEFPRICE in_print partner colourpix series bindtype covertype authorqual /],
);



package FCB_ShellieMark::RAM;

use base qw/Class::DBI Maypole::Model::Base/;
  # Model::Base for :Exported attribute handling
use Class::DBI::Relationship::HasManyToMany;

__PACKAGE__->add_relationship_type(
  has_many_to_many => "Class::DBI::Relationship::HasManyToMany",
);

__PACKAGE__->connection('dbi:AnyData:', '', '');


package FCB_ShellieMark::RAM::cart_line;

use base qw/FCB_ShellieMark::RAM/;
use Class::DBI::FromCGI;

__PACKAGE__->table('cart_line');
__PACKAGE__->columns(Essential => qw/ id quantity/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id quantity/;
}


__PACKAGE__->untaint_columns(
  integer => [qw/id quantity /],
);



package FCB_ShellieMark::RAM::tmp_card;

use base qw/FCB_ShellieMark::RAM/;
use Class::DBI::FromCGI;

__PACKAGE__->table('tmp_card');
__PACKAGE__->columns(Essential => qw/ id name cardholder_name card_number valid_from valid_to issue_number extra_code address_name address_street address_city address_state address_zip/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id name cardholder_name card_number valid_from valid_to issue_number extra_code address_name address_street address_city address_state address_zip/;
}


__PACKAGE__->untaint_columns(
  integer => [qw/id /],
  printable => [qw/name cardholder_name card_number valid_from valid_to issue_number extra_code address_name address_street address_city address_state address_zip /],
);



package FCB_ShellieMark::RAM::tmp_address;

use base qw/FCB_ShellieMark::RAM/;
use Class::DBI::FromCGI;

__PACKAGE__->table('tmp_address');
__PACKAGE__->columns(Essential => qw/ id name address_name address_street address_city address_state address_zip/);

sub display_columns {
  return map { Class::DBI::Column->new($_); } qw/ id name address_name address_street address_city address_state address_zip/;
}


__PACKAGE__->untaint_columns(
  integer => [qw/id /],
  printable => [qw/name address_name address_street address_city address_state address_zip /],
);





1;
