package FCB_ShellieMark::WWW;

use base qw/Apache::MVC FCB_ShellieMark::WWW::Authentication/;
use FCB_ShellieMark::DB;
use FCB_ShellieMark::RAM;

__PACKAGE__->config(Maypole::Config->new());
__PACKAGE__->config->uri_base('/');
__PACKAGE__->config->model('FCB_ShellieMark::WWW::Model');
__PACKAGE__->config->view('FCB_ShellieMark::WWW::View');
__PACKAGE__->setup([qw/FCB_ShellieMark::DB::user FCB_ShellieMark::DB::user_card FCB_ShellieMark::DB::user_address FCB_ShellieMark::DB::invoice FCB_ShellieMark::DB::invoice_line FCB_ShellieMark::DB::invoice_card FCB_ShellieMark::DB::invoice_address FCB_ShellieMark::DB::site FCB_ShellieMark::DB::page FCB_ShellieMark::DB::page_template FCB_ShellieMark::DB::page_text FCB_ShellieMark::DB::page_image FCB_ShellieMark::DB::category FCB_ShellieMark::DB::product FCB_ShellieMark::DB::product_template FCB_ShellieMark::DB::product_text FCB_ShellieMark::DB::product_image FCB_ShellieMark::DB::author FCB_ShellieMark::DB::security_role FCB_ShellieMark::DB::security_action FCB_ShellieMark::DB::security_role_security_action FCB_ShellieMark::DB::text_style FCB_ShellieMark::DB::delivery_method FCB_ShellieMark::DB::prod_raw_imp FCB_ShellieMark::RAM::cart_line FCB_ShellieMark::RAM::tmp_card FCB_ShellieMark::RAM::tmp_address /]);
__PACKAGE__->config->{auth}{session_class} = 'FCB_ShellieMark::WWW::Session';
__PACKAGE__->config->{auth}{session_args} = 
  {
   Store => 'MySQL',
   Lock => 'Null',
   Generate => 'MD5',
   Serialize => 'Storable',
   Handle => FCB_ShellieMark::DB->db_Main(),
   LockHandle => FCB_ShellieMark::DB->db_Main()
  };
__PACKAGE__->config->{auth}{user_field} = 'name';
__PACKAGE__->config->{auth}{password_field} = 'password';
__PACKAGE__->config->{auth}{user_class} = 'FCB_ShellieMark::DB::user';
__PACKAGE__->config->{base_classes}{main_db} = 'FCB_ShellieMark::DB';
__PACKAGE__->config->{base_classes}{virt_db} = 'FCB_ShellieMark::RAM';

sub headers {
  return scalar Apache->headers_in;
}

1;
