package FCB_ShellieMark::WWW::Model;

use Maypole::Config;
use base qw/Maypole::Model::CDBI::Plain/;
use FCB_ShellieMark::WWW::SecWrap;

use strict;
use warnings;

FCB_ShellieMark::WWW::SecWrap->add_secwrap(__PACKAGE__);

sub add_rel : Exported {
  my ($self, $r) = @_;
  return $self->_do_rel_op($r => 'add_to');
}

sub remove_rel : Exported {
  my ($self, $r) = @_;
  return $self->_do_rel_op($r => 'remove_from');
}

sub add : Exported { }

sub _do_rel_op {
  my ($self, $r, $type) = @_;
  my $h = CGI::Untaint->new( %{ $r->{params} } );
  my ($obj) = @{ $r->objects || [] };
  die "Argh!" unless $obj; # FIXME
  my $id = $h->extract(-as_integer => 'id');
  my $rel = $h->extract(-as_printable => 'rel');
  my $meth = "${type}_${rel}";
  $obj->$meth($id);
  $r->{template} = 'view';
}

sub view_image :Exported {
  my ($self, $r) = @_;
  my $obj = $r->{objects}->[0];
  $r->{content_type} = $obj->image_type;
  $r->{output} = $obj->image;
}

sub name { return $_[0]->id; }

sub do_edit : Exported {
  my ($self, $r) = @_;
  $self->SUPER::do_edit(@_[1..$#_]);
  #warn "Template ".$r->{template};
  if ($r->{template} eq 'view' && $r->{params}{_new_location} && $r->{params}{save_and_return}) {
    $r->headers_out->set('Location' => $r->{params}{_new_location});
    $r->{output} = ' ';
    $r->{ar}->status(302) if $r->{ar};
    #warn "Redirecting to ".$r->{params}{_new_location};
  }
  if ($r->{template} eq 'edit' && !(@{$r->objects})) {
    $r->{template} = 'add';
  }
}

sub copy_tmp : Exported {
  my ($self, $r) = @_;
  my ($from) = @{$r->objects || []};
  die "copy_tmp needs an object to copy" unless $from;
  my $class = ref $self || $self;
  $class =~ s/::[^_:]+_([^:]+)$/::tmp_$1/;
  $class =~ s/::DB::/::RAM::/;
  my $tmp = $class->retrieve(1);
  die "copy_tmp requires a valid tmp class" unless $tmp;
  foreach my $col ($tmp->columns) {
    $tmp->$col($from->$col) if $from->can($col);
  }
  $r->headers_out->set('Location' => $r->{params}{_new_location});
  $r->{output} = ' ';
  $r->{ar}->status(302) if $r->{ar};
}

sub display_columns {
  shift->columns;
}

1;
