package FCB_ShellieMark::WWW::Session;

use base qw/Apache::Session::Flex/;

use AnyData::Storage::RAM;
use AnyData::Format::Base;

sub TIEHASH {
  my $obj = $_[0]->SUPER::TIEHASH(@_[1..$#_]);
  my $dbh = FCB_ShellieMark::RAM->db_Main;
  if ($obj->{data}{virtual_tables}) {
    $dbh->{ad_tables} = $obj->{data}{virtual_tables};
  } else {
    warn "Creating tables";
    my @stmt = split(/\n\n/, <<EOSQL);
CREATE TABLE cart_line (
  id TEXT,
  quantity TEXT,
)

CREATE TABLE tmp_card (
  id TEXT,
  name TEXT,
  cardholder_name TEXT,
  card_number TEXT,
  valid_from TEXT,
  valid_to TEXT,
  issue_number TEXT,
  extra_code TEXT,
  address_name TEXT,
  address_street TEXT,
  address_city TEXT,
  address_state TEXT,
  address_zip TEXT,
)

CREATE TABLE tmp_address (
  id TEXT,
  name TEXT,
  address_name TEXT,
  address_street TEXT,
  address_city TEXT,
  address_state TEXT,
  address_zip TEXT,
)

INSERT INTO tmp_card (id) VALUES (1)

INSERT INTO tmp_address (id) VALUES (1)
EOSQL
    foreach (@stmt) {
      $dbh->do($_);
    }
    $obj->{data}{virtual_tables} = $dbh->{ad_tables};
  }
  return $obj;
}

sub DESTROY {
  #warn "Disconnecting";
  FCB_ShellieMark::RAM->db_Main->disconnect;
  #warn "Destroying";
  $_[0]->{status} |= Apache::Session::MODIFIED;
  $_[0]->SUPER::DESTROY(@_[1..$#_]);
  #warn "Done";
}

1;
