<transformer class="XSLT">
  <xsl:stylesheet xsl:version="1.0" xml:space="preserve"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:template match="/">
      <provision xmlns:xi="http://www.w3.org/2001/XInclude">
        <resource class="Directory" path="{config/@build_dir}"/>
        <resource class="Directory" path="{config/@build_dir}/{config/@base_perl_package}"/>
        <resource class="Directory" path="{config/@build_dir}/{config/@base_perl_package}/WWW"/>
        <resource class="Directory" path="{config/@build_dir}/{config/@base_perl_package}/DB"/>
        <resource class="File" path="{config/@build_dir}/db.sql">
          <datasource class="Composite">
            <transform href="sql_generate.xml">
              <transform href="mysql_attr.xslt">
                <transform href="auto_tables.xslt">
                  <datasource class="Literal">
                    <xi:include href="db.xml"/>
                  </datasource>
                </transform>
              </transform>
            </transform>
          </datasource>
        </resource>
        <resource class="File" path="{config/@build_dir}/ramdb.sql">
          <datasource class="Composite">
            <transform href="sql_generate.xml">
              <transform href="ramdb_attr.xslt">
                <transform href="auto_tables.xslt">
                  <datasource class="Literal">
                    <xi:include href="ramdb.xml"/>
                  </datasource>
                </transform>
              </transform>
            </transform>
          </datasource>
        </resource>
        <resource class="File" path="{config/@build_dir}/{config/@base_perl_package}/DB.pm">
          <datasource class="Composite">
            <transform href="cdbi_generate.xml">
              <transform href="cdbi_attr.xslt">
                <transform href="auto_tables.xslt">
                  <xi:include href="data.xml"/>
                </transform>
              </transform>
            </transform>
          </datasource>
        </resource>
        <resource class="File" path="{config/@build_dir}/{config/@base_perl_package}/WWW.pm">
          <datasource class="Composite">
            <transform href="maypole_generate.xml">
              <transform href="auto_tables.xslt">
                <xi:include href="data.xml"/>
              </transform>
            </transform>
          </datasource>
        </resource>
        <resource class="File" path="{config/@build_dir}/startup.pl">
          <datasource class="Composite">
            <transform href="startup_generate.xml">
              <xi:include href="data.xml"/>
            </transform>
          </datasource>
        </resource>
        <xsl:choose>
          <xsl:when test="config[@maypole_driver='Apache::MVC']">
            <resource class="File" path="{config/@build_dir}/httpd.conf">
              <datasource class="Composite">
                <transform href="httpd_conf_generate.xml">
                  <xi:include href="data.xml"/>
                </transform>
              </datasource>
            </resource>
          </xsl:when>
          <xsl:when test="config[@maypole_driver='CGI::Maypole']">
            <resource class="File" path="{config/@build_dir}/maypole.cgi">
              <datasource class="Composite">
                <transform href="maypole_cgi_generate.xml">
                  <xi:include href="data.xml"/>
                </transform>
              </datasource>
            </resource>
          </xsl:when>
        </xsl:choose>
        <resource class="File" path="{config/@build_dir}/{config/@base_perl_package}/DB/user.pm">
          <datasource class="LiteralText">1;
</datasource>
        </resource>
        <resource class="File" path="{config/@build_dir}/{config/@base_perl_package}/RAM.pm">
          <datasource class="LiteralText">1;
</datasource>
        </resource>
        <resource class="File" path="{config/@build_dir}/{config/@base_perl_package}/WWW/Authentication.pm">
          <datasource class="Composite">
            <transform href="www/auth_generate.xml">
              <xi:include href="data.xml"/>
            </transform>
          </datasource>
        </resource>
        <resource class="File" path="{config/@build_dir}/{config/@base_perl_package}/WWW/Model.pm">
          <datasource class="Composite">
            <transform href="www/model_generate.xml">
              <xi:include href="data.xml"/>
            </transform>
          </datasource>
        </resource>
        <resource class="File" path="{config/@build_dir}/{config/@base_perl_package}/WWW/SecWrap.pm">
          <datasource class="Composite">
            <transform href="www/secwrap_generate.xml">
              <xi:include href="data.xml"/>
            </transform>
          </datasource>
        </resource>
        <resource class="File" path="{config/@build_dir}/{config/@base_perl_package}/WWW/Session.pm">
          <datasource class="Composite">
            <transform href="www/session_generate.xml">
              <xi:include href="data.xml"/>
            </transform>
          </datasource>
        </resource>
        <resource class="File" path="{config/@build_dir}/{config/@base_perl_package}/WWW/View.pm">
          <datasource class="Composite">
            <transform href="www/view_generate.xml">
              <xi:include href="data.xml"/>
            </transform>
          </datasource>
        </resource>
      </provision>
    </xsl:template>
  </xsl:stylesheet>
</transformer>
