<transformer class="XSLT">
  <xsl:stylesheet xsl:version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:template match="*">
      <xsl:copy>
        <xsl:copy-of select="@*" />
        <xsl:apply-templates />
      </xsl:copy>
    </xsl:template>

    <xsl:template match="field">
      <xsl:copy>
        <xsl:copy-of select="@name" />
        <xsl:attribute name="sql_type">
          <xsl:choose>
            <xsl:when test="@class='FK' or @class='Integer'">
              <xsl:text>int(11) NOT NULL DEFAULT </xsl:text>
              <xsl:choose>
                <xsl:when test="@default">
                  <xsl:value-of select="@default" />
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>0</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:when>
            <xsl:when test="@class='Data' or @class='Image'">
              <xsl:text>MEDIUMBLOB</xsl:text>
            </xsl:when>
            <xsl:when test="@class='Boolean'">
              <xsl:text>tinyint(1) NOT NULL DEFAULT </xsl:text>
              <xsl:choose>
                <xsl:when test="@default">
                  <xsl:value-of select="@default" />
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>0</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:when>
            <xsl:when test="@class='Date'">
              <xsl:text>DATE</xsl:text>
            </xsl:when>
            <xsl:when test="@class='Currency'">
              <xsl:text>DECIMAL(10,2) NOT NULL DEFAULT </xsl:text>
              <xsl:choose>
                <xsl:when test="@default">
                  <xsl:value-of select="@default" />
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>0</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:when>
            <xsl:otherwise>
              <xsl:text>varchar(255) NOT NULL DEFAULT </xsl:text>
              <xsl:choose>
                <xsl:when test="@default">
                  <xsl:value-of select="@default" />
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>''</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:attribute>
        <xsl:if test="@class='FK'">
          <xsl:attribute name="index"><xsl:text>1</xsl:text></xsl:attribute>
        </xsl:if>
      </xsl:copy>
      <xsl:text>
</xsl:text>
    </xsl:template>
  </xsl:stylesheet>
</transformer>
