<transformer class="XSLT">
  <xsl:stylesheet xsl:version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:template match="*">
      <xsl:copy>
        <xsl:copy-of select="@*" />
        <xsl:apply-templates />
      </xsl:copy>
    </xsl:template>
    <xsl:template match="relation[@class='many_to_many']">
      <xsl:copy> 
        <xsl:copy-of select="@*" />
        <xsl:apply-templates />
      </xsl:copy>
      <table>
        <xsl:attribute name="name">
          <xsl:value-of select="@from" /><xsl:text>_</xsl:text><xsl:value-of select="@to" />
        </xsl:attribute>
        <xsl:text> </xsl:text>
        <field class="FK">
          <xsl:attribute name="name">
            <xsl:value-of select="@from" />
          </xsl:attribute>
        </field>
        <xsl:text>
</xsl:text>
        <field class="FK">
          <xsl:attribute name="name">
            <xsl:value-of select="@to" />
          </xsl:attribute>
        </field>
        <xsl:for-each select="field">
          <xsl:copy>
            <xsl:copy-of select="@*" />
            <xsl:apply-templates />
          </xsl:copy>
        </xsl:for-each>
        <xsl:text>
</xsl:text>
        <!-- <xsl:if test="@ordered">
          <field name="order_by" class="Integer" />
        <xsl:text>
</xsl:text>
        </xsl:if> -->
      </table>
      <xsl:text>
</xsl:text>
    </xsl:template>
    <xsl:template match="field[@class='Image']">
      <xsl:copy>
        <xsl:copy-of select="@*" />
        <xsl:apply-templates />
      </xsl:copy>
      <field name="image_type" class="String" />
      <field name="alt" class="String" />
    </xsl:template>
    <xsl:template match="field[@class='FK' and @ordered=1]">
      <xsl:copy><xsl:copy-of select="@*" /><xsl:apply-templates /></xsl:copy>
      <field class="Integer" index="1" >
        <xsl:attribute name="name"><xsl:text>order_in_</xsl:text><xsl:value-of select="@name" /></xsl:attribute>
      </field>
    </xsl:template>
    <xsl:template match="fieldgroup">
      <xsl:choose>
        <xsl:when test="@group='card_fields'">
          <field name="cardholder_name" class="String" />
          <field name="card_number" class="String" />
          <field name="valid_from" class="Date" />
          <field name="valid_to" class="Date" />
          <field name="issue_number" class="String" />
          <field name="extra_code" class="String" />
        </xsl:when>
        <xsl:when test="@group='address_fields'">
          <field name="address_name" class="String" />
          <field name="address_street" class="String" />
          <field name="address_city" class="String" />
          <field name="address_state" class="String" />
          <field name="address_zip" class="String" />
        </xsl:when>
      </xsl:choose>
    </xsl:template>
  </xsl:stylesheet>
</transformer>
