<transformer class="XSLT">
  <xsl:stylesheet xsl:version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:template match="/">
      <xsl:apply-templates select="L2-A-device"/>
    </xsl:template>
    <xsl:template match="L2-A-device">
      <switch-config>
        <xsl:if test="vlan">
          <mode-change type="vlan">
            <arg type="range">
              <xsl:for-each select="vlan[not(@name)]">
                <include><xsl:value-of select="@tag"/></include>
              </xsl:for-each>
            </arg>
          </mode-change>
          <xsl:for-each select="vlan[@name]">
            <mode-change type="vlan">
              <arg><xsl:value-of select="@tag"/></arg>
              <command name="name">
                <arg>"<xsl:value-of select="@name"/>"</arg>
              </command>
            </mode-change>
          </xsl:for-each>
        </xsl:if>
        <xsl:for-each select="switchport">
          <mode-change type="interface">
            <arg>
              <xsl:value-of select="@real"/>
            </arg>
            <command name="switchport"/>
            <xsl:choose>
              <xsl:when test="vlan[@mode = 'tagged']">
                <command name="switchport">
                  <arg>trunk</arg><arg>mode</arg><arg>dot1q</arg>
                </command>
                <command name="switchport">
                  <arg>allowed</arg><arg>vlan</arg>
                  <arg><xsl:for-each select="vlan"><xsl:value-of select="@tag"/>,</xsl:for-each><xsl:text>1,1002-1005</xsl:text></arg>
                </command>
                <xsl:if test="vlan[@mode = 'untagged']">
                  <command name="switchport">
                    <arg>native</arg><arg>vlan</arg>
                    <arg>
                      <xsl:value-of select="vlan[@mode = 'untagged']/@tag"/>
                    </arg>
                  </command>
                </xsl:if>
              </xsl:when>
              <xsl:otherwise>
                <command name="switchport">
                  <arg>access</arg><arg>vlan</arg>
                  <arg><xsl:value-of select="vlan[@mode = 'untagged']/@tag"/></arg>
                </command>
                <command name="switchport">
                  <arg>mode</arg><arg>access</arg>
                </command>
              </xsl:otherwise>
            </xsl:choose>
          </mode-change>
        </xsl:for-each>
        <xsl:for-each select="vlan">
          <mode-change type="interface">
            <arg>vlan</arg><arg><xsl:value-of select="@tag"/></arg>
            <xsl:if test="ip">
              <command name="ip">
                <arg>address</arg>
                <arg><xsl:value-of select="ip/@address"/></arg>
                <arg><xsl:value-of select="ip/@netmask"/></arg>
              </command>
            </xsl:if>
            <xsl:choose>
              <xsl:when test="@shutdown = '1'">
                <command name="shutdown"></command>
              </xsl:when>
              <xsl:otherwise>
                <command name="no"><arg>shutdown</arg></command>
              </xsl:otherwise>
            </xsl:choose>
          </mode-change>
        </xsl:for-each>
      </switch-config>
    </xsl:template>
  </xsl:stylesheet>
</transformer>
