<transformer class="XSLT">
  <xsl:stylesheet xsl:version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:template match="/">
      <xsl:apply-templates select="L2-A-device"/>
    </xsl:template>
    <xsl:template match="L2-A-device">
      <switch-config>
        <xsl:for-each select="vlan">
          <mode-change type="vlan">
            <arg><xsl:value-of select="@tag"/></arg>
            <xsl:if test="@name">
              <command name="name">
                <arg>"<xsl:value-of select="@name"/>"</arg>
              </command>
            </xsl:if>
            <xsl:if test="../switchport/vlan[@tag = current()/@tag and @mode = 'tagged']">
              <command name="tagged">
                <arg type="range">
                  <xsl:for-each select="../switchport/vlan[@tag = current()/@tag and @mode = 'tagged']">
                    <include><xsl:value-of select="../@real"/></include>
                  </xsl:for-each>
                </arg>
              </command>
            </xsl:if>
            <xsl:if test="../switchport/vlan[@tag = current()/@tag and @mode = 'untagged']">
              <command name="untagged">
                <arg type="range">
                  <xsl:for-each select="../switchport/vlan[@tag = current()/@tag and @mode = 'untagged']">
                    <include><xsl:value-of select="../@real"/></include>
                  </xsl:for-each>
                </arg>
              </command>
            </xsl:if>
            <xsl:if test="ip">
              <command name="ip">
                <arg>address</arg>
                <arg><xsl:value-of select="ip/@address"/></arg>
                <arg><xsl:value-of select="ip/@netmask"/></arg>
              </command>
            </xsl:if>
          </mode-change>
        </xsl:for-each>
      </switch-config>
    </xsl:template>
  </xsl:stylesheet>
</transformer>
